//+------------------------------------------------------------------+
//|                                                      scr CCI.mq5 |
//|                                                      Aleksej1966 |
//|                        https://www.mql5.com/ru/users/aleksej1966 |
//+------------------------------------------------------------------+
#property copyright "Aleksej1966"
#property link      "https://www.mql5.com/ru/users/aleksej1966"
#property version   "1.00"
#include <Graphics\Graphic.mqh>

input ushort iPeriod=7;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
//---
   int array[][2],size=0,mad[][2],s=0;
   int price[],period=2*MathMax(1,iPeriod)+1,bars=MathMin(iBars(_Symbol,PERIOD_CURRENT),TerminalInfoInteger(TERMINAL_MAXBARS));

   ArrayResize(array,size,1000);
   ArrayResize(mad,s,1000);
   ArrayResize(price,period);

   for(int i=bars-period-2; i>=0; i--)
     {
      int cur_price=(int)MathRound(iOpen(_Symbol,PERIOD_CURRENT,i)/_Point);
      price[0]=cur_price;

      for(int j=1; j<period; j++)
         price[j]=(int)MathRound(iOpen(_Symbol,PERIOD_CURRENT,i+j)/_Point);

      ArraySort(price);

      int median=price[period/2],diff=cur_price-median,ind=ArrayBsearch(array,diff);

      if(ind>=0 && array[ind][0]==diff)
         array[ind][1]++;
      else
        {
         ArrayResize(array,size+1);
         array[size][0]=diff;
         array[size][1]=1;
         size++;
         ArraySort(array);
        }

      for(int j=0; j<period; j++)
         price[j]=MathAbs(price[j]-median);

      ArraySort(price);
      int stdev=price[period/2];
      ind=ArrayBsearch(mad,stdev);

      if(ind>=0 && mad[ind][0]==stdev)
         mad[ind][1]++;
      else
        {
         ArrayResize(mad,s+1);
         mad[s][0]=stdev;
         mad[s][1]=1;
         s++;
         ArraySort(mad);
        }
     }

   ChartSetInteger(0,CHART_SHOW,false);
   int w=640,//(int)ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,0),
       h=360;//(int)ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,0);

   double x[],y[];
   ArrayResize(x,size);
   ArrayResize(y,size);

   for(int i=0; i<size; i++)
     {
      x[i]=array[i][0];
      y[i]=array[i][1];
     }

   CGraphic graph;
   graph.Create(0,"Median",0,0,0,w,h);
   CCurve *hist=graph.CurveAdd(x,y,CURVE_HISTOGRAM,"Median");
   graph.CurvePlotAll();
   graph.Update();

   ChartScreenShot(0,"Median.png",w,h);
   Sleep(3000);

   graph.Destroy();

   ArrayResize(x,s);
   ArrayResize(y,s);

   for(int i=0; i<s; i++)
     {
      x[i]=mad[i][0];
      y[i]=mad[i][1];
     }

   CGraphic graphic;
   graphic.Create(0,"StDev",0,0,0,w,h);
   hist=graphic.CurveAdd(x,y,CURVE_HISTOGRAM,"StDev");
   graphic.CurvePlotAll();
   graphic.Update();

   ChartScreenShot(0,"StDev.png",w,h);
   Sleep(3000);

   graphic.Destroy();

   ChartSetInteger(0,CHART_SHOW,true);
//---
  }
//+------------------------------------------------------------------+
